/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2009 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _ACCOUNT_H
#define	_ACCOUNT_H

#include <QString>

#include "IDableEntity.h"
#include "Money.h"
#include "Constants.h"

class Account : public IDableEntity {
public:
  Account( int _id = NOID );
  Account( const Account& orig );
  virtual ~Account( ) {}

  Account& operator=(const Account& a );
  bool operator<( const Account& a ) const;

  void setName( const QString& newname );
  QString getName( ) const;

  void setType( const AccountType& t );
  AccountType getType( ) const;

  /**
   * Sets the balance of this account.
   * @param m the value
   * @param type what type of balance to set
   */
  void setBalance( const Money& m, AccountBalance type = Current );
  /**
   * Gets the balance of this account
   * @param type the type of balance to get
   * @return
   */
  Money getBalance( AccountBalance type = Current ) const;

  void setNumber( const QString& n );
  QString getNumber( ) const;

  void setNotes( const QString& n );
  QString getNotes( ) const;

  void setTaxRate( int t );
  int getTaxRate( ) const;

  void setParentId( int pid );
  int getParentId( ) const;

  bool isRightPlus( ) const;

private:
  QString name;
  AccountType type;
  Money obal;
  Money cbal;
  Money rbal;
  QString number;
  QString notes;
  int taxrate;
  int parentid;
};

#endif	/* _ACCOUNT_H */

