/*
 * File:   AccountUtils.h
 * Author: ryan
 *
 * Created on November 19, 2011, 11:29 AM
 */

#ifndef ACCOUNTUTILS_H
#define	ACCOUNTUTILS_H

#include <QDate>
#include <QString>

#include "Constants.h"
#include "Money.h"

class QSqlDatabase;
class QHacc;
class Account;
class Journal;

class AccountUtils {
public:
  AccountUtils( QSqlDatabase& conn, QHacc * e );
  AccountUtils( const AccountUtils& orig );
  virtual ~AccountUtils( ){}

  QString longName( const Account& a ) const;
  QString longName( int id ) const;
  Money balanceOn( const Account& a, const QDate& d = QDate::currentDate( ),
      AccountBalance type = Current ) const;
  AccountType getAccountType( int aid ) const;
  bool isRightPlus( int aid ) const;
  QList<Account> getAccounts( AccountType t );
  QList<Account> getMostPopularAccounts( AccountType t, int topx = 0 );
  QList<Account> getMostPopularPairAccounts( int aid, AccountType type, int topx = 0 );

private:
  AccountUtils( );

  QSqlDatabase * conn;
  QHacc * engine;
};

#endif	/* ACCOUNTUTILS_H */

