#ifndef BUDGETUTILS_H
#define BUDGETUTILS_H

#include "Constants.h"
#include "Money.h"
#include "Account.h"

#include <map>

#include <QDate>

class QSqlDatabase;
class QHacc;
class Budget;

class BudgetUtils {
public:
  BudgetUtils( QSqlDatabase& conn, QHacc * e );
  BudgetUtils( const BudgetUtils &orig );
  virtual ~BudgetUtils( ){}

  bool isOverBudget( const Budget& b, const QDate& end = QDate::currentDate() ) const;

  /**
    * Returns a map of accounts and their balance. The "other limit" limit
    * will have an account with id = NOID.
    */
  std::map<Account, Money> budgetBreakdown( const Budget& b,
               const QDate& end = QDate::currentDate() ) const;

private:
  QSqlDatabase * conn;
  QHacc * engine;
};



#endif // BUDGETUTILS_H
