/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************/

#ifndef _CONSTANTS_H
#define	_CONSTANTS_H

#include <QString>

enum AccountType {
  Asset = 1, Liability, Equity, Revenue, Expense
};

enum ReconcileState {
  No = 1, Maybe, Yes
};

enum TransactionType {
  Normal = 1, Void, Template, AccountDefault
};

enum AccountBalance {
  Current = 0, Opening, Reconciled
};

enum BudgetTime {
  MonthToDate = 1, RunningMonth, YearToDate, RunningYear
};

enum ScheduleType {
  Unscheduled = 0, Monthly, BiWeekly, LastDay, BiMonthly, Annually, Weekly, Daily
};

/**
 * QSettings keys
 */
const QString CurrencySeparator = "CurrencySeparator";
const QString AccountSeparator = "AccountSeparator";
const QString CurrencySymbol = "CurrencySymbol";

const QString OpenAccountId = "OpenAccountId";
const QString OpenJournalId = "OpenJournalId";
const QString Database = "Database";
const QString DateFormat = "DateFormat";
const QString ShowAllTrans = "ShowAllTrans";
const QString ShowAllPayees = "ShowAllPayees";
const QString StartInQuickEntry = "StartInQuickEntry";
const QString FiltersInEffect = "Filters/InEffect";
const QString FiltersTime = "Filters/Time";
const QString FiltersUnrec = "Filters/Unrec";
const QString FiltersPayee = "Filters/Payee";

#endif	/* _CONSTANTS_H */

