/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _DBMAPPER_H
#define	_DBMAPPER_H

#include <QObject>
#include <QList>
#include <QCache>
#include <QSqlDatabase>

#include "MapperException.h"

class QHacc;
class QSqlDatabase;

template<class T> class DBMapper {
public:

  DBMapper( const QSqlDatabase& db, const QHacc * e ) {
    connection = db;
    engine = e;
  }

  DBMapper( const DBMapper& orig ) {
    connection = orig.connection;
    engine = orig.engine;
  }

  virtual ~DBMapper( ) {}

  virtual T getById( int id ) throw ( MapperException ) = 0;

  virtual QList<T> getAll( ) throw ( MapperException ) = 0;

  virtual void save( T& saveme ) throw ( MapperException ) = 0;

  virtual void update( T& updateme ) throw ( MapperException ) = 0;

  virtual void remove( const T& removeme ) throw ( MapperException ) = 0;

protected:

  QSqlDatabase& getConnection( ) const {
    return connection;
  }

  QCache<int, T> cache;
  const QHacc * engine;

private:
  QSqlDatabase connection;

};

#endif	/* _DBMAPPER_H */

