/*
 * File:   EngineNotifier.cpp
 * Author: ryan
 */

#include "EngineNotifier.h"
#include "FullTransaction.h"
#include "Budget.h"

EngineNotifier::EngineNotifier( QObject * p ) : QObject( p ) {
}

void EngineNotifier::account( const Account& older, const Account& newer ) {
  emit accountChanged( older, newer );
}

void EngineNotifier::account( const Account& acct ) {
  emit accountAdded( acct );
}

void EngineNotifier::account( int id ) {
  emit accountRemoved( id );
}

void EngineNotifier::transaction( const Transaction& older,
    const Transaction& newer ) {
  emit transactionChanged( older, newer );
}

void EngineNotifier::transaction( const Transaction& trans ) {
  emit transactionAdded( trans );
}

void EngineNotifier::transaction( const FullTransaction& older,
    const FullTransaction& newer ) {
  emit transactionChanged( older, newer );
}

void EngineNotifier::transaction( const FullTransaction& trans ) {
  emit transactionAdded( trans );
}

void EngineNotifier::transaction( int id ) {
  emit transactionRemoved( id );
}

void EngineNotifier::split( const Split& older, const Split& newer ) {
  emit splitChanged( older, newer );
}

void EngineNotifier::split( const Split& trans ) {
  emit splitAdded( trans );
}

void EngineNotifier::split( int id ) {
  emit splitRemoved( id );
}

void EngineNotifier::journal( const Journal& older, const Journal& newer ) {
  emit journalChanged( older, newer );
}

void EngineNotifier::journal( const Journal& journal ) {
  emit journalAdded( journal );
}

void EngineNotifier::journal( int id ) {
  emit journalRemoved( id );
}

void EngineNotifier::budget(const Budget &b ){
  emit overBudget( b );
}
