/*
 * File:   EngineNotifier.h
 * Author: ryan
 */

#ifndef ENGINENOTIFIER_H
#define	ENGINENOTIFIER_H

#include <QObject>

class Account;
class FullTransaction;
class Transaction;
class Split;
class Journal;
class Budget;

class EngineNotifier : public QObject {
  Q_OBJECT
public:
  EngineNotifier( QObject * p = 0 );
  virtual ~EngineNotifier( ) {}

  void account( const Account& older, const Account& newer );
  void account( const Account& acct );
  void account( int id );

  void transaction( const Transaction& older, const Transaction& newer );
  void transaction( const Transaction& trans );
  void transaction( const FullTransaction& older, const FullTransaction& newer );
  void transaction( const FullTransaction& trans );
  void transaction( int id );

  void split( const Split& older, const Split& newer );
  void split( const Split& trans );
  void split( int id );

  void journal( const Journal& older, const Journal& newer );
  void journal( const Journal& journal );
  void journal( int id );

  void budget( const Budget& );

signals:
  void accountChanged( const Account& older, const Account& newer );
  void accountAdded( const Account& acct );
  void accountRemoved( int id );

  void transactionChanged( const Transaction& older, const Transaction& newer );
  void transactionAdded( const Transaction& trans );
  void transactionRemoved( int id );

  void transactionChanged( const FullTransaction& older, const FullTransaction& newer );
  void transactionAdded( const FullTransaction& trans );

  void splitChanged( const Split& older, const Split& newer );
  void splitAdded( const Split& trans );
  void splitRemoved( int id );

  void journalChanged( const Journal& older, const Journal& newer );
  void journalAdded( const Journal& journal );
  void journalRemoved( int id );

  void overBudget( const Budget& );

private:

};

#endif	/* ENGINENOTIFIER_H */

