/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#include "IDableEntity.h"

const int IDableEntity::NOID = -1;

IDableEntity::IDableEntity( int _id = NOID ) {
  setId( _id );
}

IDableEntity::IDableEntity( const IDableEntity& orig ) {
  setId( orig.getId( ) );
}

int IDableEntity::getId( ) const {
  return id;
}

void IDableEntity::setId( int _id ) {
  id = _id;
}

IDableEntity& IDableEntity::operator=(const IDableEntity& e ) {
  if ( this != &e ) {
    id = e.getId( );
  }
  return *this;
}

bool IDableEntity::operator==(const IDableEntity& e ) const {
  return id == e.getId( );
}

bool IDableEntity::operator!=(const IDableEntity& e ) const {
  return id != e.getId( );
}
