#ifndef LOAN_H
#define LOAN_H

#include "IDableEntity.h"
#include "Money.h"

#include <QString>

class Loan : public IDableEntity {
public:
  Loan( int _id = NOID );
  Loan( const Loan& orig );
  virtual ~Loan(){}

  Loan& operator=( const Loan& a );

  void setName( const QString& str );
  const QString& getName() const;

  void setPeriods( int p );
  int getPeriods() const;

  void setPayment( const Money& m );
  const Money& getPayment() const;

  void setAmount( const Money& m );
  const Money& getAmount() const;

  void setYearlyInterestRate( double rate );
  double getYearlyInterestRate() const;
  double getPeriodInterestRate() const;

  void setPrincipalAccountId( int aid );
  int getPrincipalAccountId() const;

  void setInterestAccountId( int aid );
  int getInterestAccountId() const;

  Money getPrincipalPayment( const Money& loanBalance ) const;
  Money getInterestPayment( const Money& loanBalance ) const;

private:
  QString name;
  int periods;
  Money payment;
  Money amount;
  double periodRate;
  int principalAccountId;
  int interestAccountId;
};

#endif // LOAN_H
