
#include "LoanUtils.h"
#include "Loan.h"
#include "Account.h"
#include "Journal.h"
#include "Split.h"
#include "Transaction.h"
#include "TransactionUtils.h"
#include "QHacc.h"
#include "AccountMapper.h"

LoanUtils::LoanUtils( QSqlDatabase& c, QHacc * eng ) {
  conn = &c;
  engine = eng;
}

LoanUtils::LoanUtils( const LoanUtils& orig ){
  conn = orig.conn;
  engine = orig.engine;
}

void LoanUtils::addPayment( const Loan& l, const Account& fromAccount,
                            const Transaction& t ){
  AccountMapper& amap = QHacc::getInstance()->getAccountMapper();
  const Account& principalAcct = amap.getById( l.getPrincipalAccountId() );
  const Money& loanValue = principalAcct.getBalance();

  QList<Split> splits;

  Split s1;
  s1.setAccountId( fromAccount.getId() );
  s1.setValue( l.getPayment().opposite() );
  splits << s1;

  Split s2;
  s2.setAccountId(l.getInterestAccountId() );
  s2.setValue( l.getInterestPayment( loanValue ) );
  splits << s2;

  Split s3;
  s3.setAccountId( l.getPrincipalAccountId() );
  s3.setValue( l.getPrincipalPayment( loanValue ) );
  splits << s3;

  TransactionUtils& tutils = QHacc::getInstance()->getTransactionUtils();
  FullTransaction ft( t, splits );
  tutils.save( ft );
}
