/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _MONEY_H
#define	_MONEY_H

#include <QString>

class Money {
public:
  Money( int i = 0 );
  Money( const Money& orig );
  virtual ~Money( ){}

  Money operator+( const Money& o ) const;
  Money operator-( const Money& o ) const;
  double operator/( const Money& o ) const;
  Money operator-() const;
  Money & operator+=( const Money& o );
  Money & operator-=( const Money& o );
  Money & operator=( const Money& o );
  Money & operator=( const int );
  Money & operator=( const QString& s );
  bool operator==( const Money& o ) const;
  bool operator!=( const Money& o ) const;
  bool operator==( const int ) const;
  bool operator!=( const int ) const;
  bool operator>( const Money& o ) const;
  bool operator<( const Money& o ) const;
  bool operator>( int i ) const;
  bool operator<( int i ) const;
  bool oppositeSign( const Money& o ) const;
  bool isPositive( ) const;
  bool isZero( ) const;
  bool isNonZero() const;
  bool isNegative( ) const;
  bool isNonNegative( ) const;
  void negate( );
  Money abs() const;
  Money opposite( ) const;

  static Money getMoney( const QString& s );
  static QString value( const Money& m );
  static QString value( const QString& s );
  QString toString( ) const;
  QString toPositiveString( ) const;
  double toDouble( ) const;

  int getValue( ) const;
  void setValue( int i );
private:
  int val;

  static const int ROLLOVER;
  static const int DECIMALS;
};

#endif	/* _MONEY_H */
