/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _SPLIT_H
#define	_SPLIT_H

#include <QDate>

#include "IDableEntity.h"
#include "Constants.h"
#include "Money.h"

class Split : public IDableEntity {
public:
  Split( int id = NOID );
  Split( const Split& orig );
  Split& operator=( const Split& split );
  virtual ~Split( ){}

  Split & setValue( const Money& m );
  Money getValue( ) const;

  Split & setReconciled( const ReconcileState& rs, const QDate& = QDate() );
  ReconcileState getReconciled( ) const;

  QDate getReconcileDate( ) const;

  Split & setTaxRate( int tr );
  int getTaxRate( ) const;

  Split & setMemo( const QString& m );
  QString getMemo( ) const;

  Split & setAccountId( int id );
  int getAccountId( ) const;

  bool hasAccount() const;

  QString toString() const;

private:
  int accountid;
  Money amount;
  ReconcileState reco;
  QDate recodate;
  int taxrate;
  QString memo;
};

#endif	/* _SPLIT_H */
