/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _TRANSACTION_H
#define	_TRANSACTION_H

#include <QDate>
#include <QString>

#include "Constants.h"
#include "IDableEntity.h"

class Transaction : public IDableEntity {
public:
  Transaction( int id = NOID );
  Transaction( const Transaction& orig );
  Transaction& operator=( const Transaction& orig );
  virtual ~Transaction( ){}

  void setDate( const QDate& d );
  const QDate& getDate( ) const;

  void setMemo( const QString& m );
  const QString& getMemo( ) const;

  void setJournalId( int id );
  int getJournalId( ) const;

  void setNumber( const QString& s );
  const QString& getNumber( ) const;

  void setPayee( const QString& s );
  const QString& getPayee( ) const;

  void setType( const TransactionType& tt );
  TransactionType getType( ) const;

  bool operator==( const Transaction& ) const;

private:
  int journalid;
  QDate date;
  QString payee;
  QString memo;
  QString number;
  TransactionType type;
};

uint qHash( const Transaction& t );

#endif	/* _TRANSACTION_H */

