/*
 * File:   TransactionHandle.h
 * Author: ryan
 *
 * Created on November 27, 2011, 9:41 PM
 */

#ifndef TRANSACTIONHANDLE_H
#define	TRANSACTIONHANDLE_H

#include <QString>
#include <QDate>

#include "Constants.h"
#include "IDableEntity.h"

class TransactionSchedule : public IDableEntity {
public:
  TransactionSchedule( int id = IDableEntity::NOID, ScheduleType typ = Unscheduled,
                       int tid = IDableEntity::NOID, const QString& n = QString(),
                       const QDate& next = QDate() );
  TransactionSchedule( const TransactionSchedule& orig );
  TransactionSchedule& operator=( const TransactionSchedule& );
  virtual ~TransactionSchedule( ){}

  void setName( const QString& name );
  const QString& getName( ) const;

  void setShortcut( const QString& sc );
  const QString& getShortcut( ) const;

  void setTransactionId( int id );
  int getTransactionId( ) const;

  bool isNull() const;

  ScheduleType getType() const;

  void setNextRun( const QDate& d, ScheduleType ty );
  const QDate& getNextRun() const;

  bool isDue( const QDate& since = QDate::currentDate() ) const;

private:
  int transid;
  QString name;
  QString shortcut;
  ScheduleType type;
  QDate nextrun;

  friend class TransactionMapper;
  friend class TransactionUtils;
};

#endif	/* TRANSACTIONHANDLE_H */

