
########################################################
#                          #
#  You should not need to touch anything in this file  #
#                          #
########################################################

include ( ../user.pri )

TEMPLATE = lib
TARGET = engine
DEPENDPATH += . mapper
INCLUDEPATH += . mapper
QT -= gui
QT += sql
CONFIG += shared qt

incos.path = $${HINSTALLDIR}
incos.files = *.h

incos2.path = $${HINSTALLDIR}/mapper
incos2.files = mapper/*.h

target.path = $${LIBINSTALLDIR}

INSTALLS += target incos incos2

win32 {
  mingwlibo.path = $${LIBINSTALLDIR}
  # NOTE: the last file doesn't copy because of unescaped +s.
  mingwlibo.files = $${MINGW}/bin/libgcc_s_dw2-1.dll $${MINGW}/bin/mingwm10.dll $${MINGW}/bin/libstdc++-6.dll 
  INSTALLS += mingwlibo
}

# Input
HEADERS += \
    Account.h \
    AccountUtils.h \
    Constants.h \
    DBMapper.h \
    EngineNotifier.h \
    FullTransaction.h \
    IDableEntity.h \
    Journal.h \
    Logger.h \
    Money.h \
    QHacc.h \
    Split.h \
    Transaction.h \
    TransactionUtils.h \
    mapper/AccountMapper.h \
    mapper/JournalMapper.h \
    mapper/MapperException.h \
    mapper/SplitMapper.h \
    mapper/TransactionMapper.h \
    Loan.h \
    mapper/LoanMapper.h \
    LoanUtils.h \
    Budget.h \
    mapper/BudgetMapper.h \
    BudgetUtils.h \
    TransactionSchedule.h
SOURCES += Account.cpp \
    AccountUtils.cpp \
    EngineNotifier.cpp \
    FullTransaction.cpp \
    IDableEntity.cpp \
    Journal.cpp \
    Logger.cpp \
    Money.cpp \
    QHacc.cpp \
    Split.cpp \
    Transaction.cpp \
    TransactionUtils.cpp \
    mapper/AccountMapper.cpp \
    mapper/JournalMapper.cpp \
    mapper/MapperException.cpp \
    mapper/SplitMapper.cpp \
    mapper/TransactionMapper.cpp \
    Loan.cpp \
    mapper/LoanMapper.cpp \
    LoanUtils.cpp \
    Budget.cpp \
    mapper/BudgetMapper.cpp \
    BudgetUtils.cpp \
    TransactionSchedule.cpp
