/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _ACCOUNTMAPPER_H
#define	_ACCOUNTMAPPER_H

#include "DBMapper.h"
#include "Account.h"

class QSqlDatabase;

class AccountMapper : public DBMapper<Account> {
public:
  AccountMapper( const QSqlDatabase& db, const QHacc * e );
  AccountMapper( const AccountMapper& orig );
  virtual ~AccountMapper( ){}

  virtual Account getById( int id ) throw ( MapperException);

  QList<Account> getAll( ) throw ( MapperException);

  /**
   * Gets the children account for the specified parent id. If id=0, return
   * all top-level accounts.
   * @param id the parent id
   * @return a list of children accounts
   */
  QList<Account> getChildren( int id = 0 ) throw ( MapperException);

  virtual void save( Account& saveme ) throw ( MapperException);

  virtual void update( Account& updateme ) throw ( MapperException);

  virtual void remove( const Account& removeme ) throw ( MapperException);

  virtual void updateBalances( Account& acct,
      bool doSignal = true ) throw ( MapperException);
};

#endif	/* _ACCOUNTMAPPER_H */

