#ifndef BUDGETMAPPER_H
#define BUDGETMAPPER_H

#include "DBMapper.h"
#include "Budget.h"

class QSqlDatabase;

class BudgetMapper : public DBMapper<Budget> {
public:
  BudgetMapper( const QSqlDatabase& db, const QHacc * e );
  BudgetMapper( const BudgetMapper& orig );
  virtual ~BudgetMapper( ){}

  virtual Budget getById( int id ) throw ( MapperException);

  QList<Budget> getAll( ) throw ( MapperException);

  QList<Budget> getAllFor( int aid ) throw ( MapperException);

  virtual void save( Budget& saveme ) throw ( MapperException);

  virtual void update( Budget& updateme ) throw ( MapperException);

  virtual void remove( const Budget& removeme ) throw ( MapperException);
};


#endif // BUDGETMAPPER_H
