/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2009 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************/

#ifndef _JournalMAPPER_H
#define	_JournalMAPPER_H

#include "DBMapper.h"
#include "Journal.h"

class QSqlDatabase;

class JournalMapper : public DBMapper<Journal> {
public:
  JournalMapper( const QSqlDatabase& conn, const QHacc * e );
  JournalMapper( const JournalMapper& orig );
  virtual ~JournalMapper( ){}

  virtual Journal getById( int id ) throw ( MapperException );

  QList<Journal> getAll() throw ( MapperException );

  virtual void save( Journal& saveme ) throw ( MapperException );

  virtual void update( Journal& updateme ) throw ( MapperException );

  virtual void remove( const Journal& removeme ) throw ( MapperException );

private:

};

#endif	/* _JournalMAPPER_H */

