/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************/

#ifndef _SPLITMAPPER_H
#define	_SPLITMAPPER_H

#include <QDate>

#include "DBMapper.h"
#include "Split.h"
#include "Journal.h"

class Account;
class Transaction;

class SplitMapper : public DBMapper<Split> {
public:
  SplitMapper( const QSqlDatabase& conn, const QHacc * e );
  virtual ~SplitMapper( ){}

  virtual Split getById( int id ) throw ( MapperException );

  QList<Split> getAll( ) throw ( MapperException );

  QList<Split> getAll( const Transaction& t ) throw ( MapperException );

  QList<Split> getAll( const Account& a,
      const Journal& j = Journal( ), const QDate& end = QDate( ),
      const QDate& start = QDate( ) ) throw ( MapperException );

  virtual void save( Split& saveme ) throw ( MapperException );

  virtual void update( Split& updateme ) throw ( MapperException );

  virtual void remove( const Split& removeme ) throw ( MapperException );

  virtual void remove( int id ) throw ( MapperException );

private:
  SplitMapper( const SplitMapper& orig );
};

#endif	/* _SPLITMAPPER_H */
