/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************
 * Created on July 12, 2009, 5:25 PM
 */

#ifndef _TRANSACTIONMAPPER_H
#define	_TRANSACTIONMAPPER_H

#include "DBMapper.h"
#include "Transaction.h"
#include "TransactionSchedule.h"

class QSqlDatabase;

class TransactionMapper : public DBMapper<Transaction> {
public:
  TransactionMapper( const QSqlDatabase& conn, const QHacc * e );
  TransactionMapper( const TransactionMapper& orig );
  virtual ~TransactionMapper( ){}

  virtual Transaction getById( int id ) throw ( MapperException );

  virtual Transaction getByName( const QString& name ) throw ( MapperException );

  virtual Transaction getBySchedule( const TransactionSchedule& ts ) throw ( MapperException );

  virtual TransactionSchedule getSchedule( const QString& name ) throw ( MapperException );

  virtual TransactionSchedule getSchedule( int schedid ) throw ( MapperException );

  virtual QList<TransactionSchedule> getSchedules( const Transaction& t ) throw ( MapperException );

  virtual bool isScheduled( int transid ) throw ( MapperException );

  virtual QList<Transaction> getAll( ) throw ( MapperException );

  virtual QList<TransactionSchedule> getSchedules( ) throw ( MapperException );

  virtual void save( Transaction& saveme ) throw ( MapperException );

  virtual void update( Transaction& updateme ) throw ( MapperException );

  virtual void remove( const Transaction& removeme ) throw ( MapperException );

  virtual void update( TransactionSchedule& updateme ) throw ( MapperException );

  virtual void unschedule( const Transaction& removeme ) throw ( MapperException );

  virtual void unschedule( const TransactionSchedule& removeme ) throw ( MapperException );

  virtual void schedule( const Transaction& t, TransactionSchedule& s ) throw ( MapperException );

private:

};

#endif	/* _TRANSACTIONMAPPER_H */

