/*
 * File:   AccountChooser.h
 * Author: ryan
 */

#ifndef ACCOUNTCHOOSER_H
#define	ACCOUNTCHOOSER_H

#include <QTreeWidget>

#include "Account.h"

class AccountChooser : public QTreeWidget {
  Q_OBJECT
public:
  AccountChooser( QWidget * p = 0 );
  virtual ~AccountChooser( ){}

  const Account& getCurrent() const;

public slots:
  /**
   * Sets the account without firing signals
   */
  void selectAccount( const Account& a );
  /**
   * Sets the account as if the user clicked on it
   */
  void setAccount( const Account& a );
  void accountUpdated( const Account& older, const Account& newer );
  void accountChanged( QTreeWidgetItem * item, int col );
  void refresh( );
  void saveSettings();
  void restoreSettings();

signals:
  void accountSelected( const Account& acct );

private:
  QHash<int, QTreeWidgetItem *> iditemlkp;
  Account current;
};

class QHaccAccountTreeWidgetItem : public QTreeWidgetItem {
public:
  QHaccAccountTreeWidgetItem( const Account& a, AccountChooser * parent );
  QHaccAccountTreeWidgetItem( const Account& a, QHaccAccountTreeWidgetItem * p );
  bool operator<(const QTreeWidgetItem& other ) const;

  virtual ~QHaccAccountTreeWidgetItem( ){}
private:
  void init( const Account& a );
};

#endif	/* ACCOUNTCHOOSER_H */
