
#include "AccountComboBox.h"

#include "QHacc.h"
#include "AccountMapper.h"
#include "AccountUtils.h"

#include <QStringList>

AccountComboBox::AccountComboBox( QWidget * p,  bool showAddNew ) : QComboBox( p ){

  AccountMapper& amap = QHacc::getInstance( )->getAccountMapper( );
  AccountUtils& autils = QHacc::getInstance( )->getAccountUtils( );

  QHash<QString, int> accounts;
  QStringList anames;

  for( const Account& acct : amap.getAll( ) ) {
    QString longname = autils.longName( acct );
    accounts[longname] = acct.getId( );
    anames << longname;
  }
  anames.sort( );

  if( showAddNew ){
    addItem( tr( "New Account" ), IDableEntity::NOID );
  }

  for( const QString& s : anames ) {
    addItem( s, accounts[s] );
  }
}
