/*
 * File:   DataEntry.h
 * Author: ryan
 */

#ifndef DATAENTRY_H
#define	DATAENTRY_H

#include <QList>
#include <QStringListModel>
#include <memory>

#include "ui_DataEntry.h"

#include "Split.h"
#include "Transaction.h"
#include "FullTransaction.h"

class Journal;
class SplitModel;
class AccountDelegate;
class ReconcileDelegate;
class QModelIndex;
class QCompleter;

class DataEntry : public QWidget {
  Q_OBJECT
public:
  DataEntry( QWidget * p = 0 );
  virtual ~DataEntry( );

  static ReconcileState getRec( Qt::CheckState s );
  static Qt::CheckState getState( ReconcileState rs );
  void keyPressEvent(QKeyEvent *);

public slots:
  void edit( const FullTransaction& t );
  void editNew( );
  void saveData( );
  void changeJournal( const Journal& j );
  void openSplitEditor();
  void chooseCompletion( const QString& str );

private:
  Ui::DataEntry widget;
  FullTransaction fulltrans;
  int journalid;
  std::unique_ptr<QCompleter> pcompleter;
  std::unique_ptr<QCompleter> vcompleter;
  QStringListModel pcompleterModel;
  QStringListModel vcompleterModel;
  bool loading;

  void setTransData( const Transaction& t );
  void setSplitData( const QList<Split>& s );
  QList<Split> getSplitsForSave( bool& ok);
  void setupAccounts();
};

#endif	/* DATAENTRY_H */
