/*
 * File:   DateDelegate.cpp
 * Author: ryan
 *
 * Created on November 30, 2011, 2:16 PM
 */

#include <QDateTimeEdit>
#include <QSettings>
#include <QPainter>
#include <QLinearGradient>
#include <QStyleOptionViewItemV4>

#include "DateDelegate.h"
#include "Constants.h"
#include "AccountViewer.h"

DateDelegate::DateDelegate( QObject * p ) : TransactionDelegateBase( p ) {
}

QWidget * DateDelegate::createEditor( QWidget * parent,
    const QStyleOptionViewItem &, const QModelIndex & ) const {
  QDateEdit * qde = new QDateEdit( parent );
  return qde;
}

void DateDelegate::setEditorData( QWidget * editor,
    const QModelIndex &index ) const {
  QDateEdit * qde = static_cast<QDateEdit *> ( editor );
  qde->setDate( index.data( Qt::UserRole ).toDate( ) );
}

void DateDelegate::setModelData( QWidget *editor, QAbstractItemModel *model,
    const QModelIndex &index ) const {
  QDateEdit * qde = static_cast<QDateEdit *> ( editor );
  QDate date = qde->date( );
  model->setData( index, date, Qt::EditRole );
}

void DateDelegate::updateEditorGeometry( QWidget *editor,
    const QStyleOptionViewItem &option, const QModelIndex & ) const {
  editor->setGeometry( option.rect );
}

QString DateDelegate::displayText( const QVariant& val, const QLocale& ) const {
  QSettings settings;
  QString format = settings.value( DateFormat ).toString( );
  return val.toDate( ).toString( format );
}
