#include "FilterViewDialog.h"

#include <QSettings>
#include <QButtonGroup>

#include "Constants.h"

FilterViewDialog::FilterViewDialog(QWidget *parent) :
  QDialog( parent ), bgroup( new QButtonGroup( this ) ) {
  widget.setupUi( this );

  bgroup->setExclusive( true );
  QAbstractButton * checks[] = { widget.currentmonth, widget.currentyear,
                                 widget.currentwindow,
                                 widget.onemonth, widget.threemonths,
                                 widget.sixmonths, widget.oneyear };
  int ids[] = { -3, -12, -2, 1, 3, 6, 12 };

  for( int i = 0; i < 7; i++ ){
    bgroup->addButton( checks[i], ids[i] );
  }

  QSettings settings;
  int months = settings.value( FiltersTime, 0 ).toInt();
  if( 0 != months ){
    QAbstractButton * btn = bgroup->button( months );
    btn->setChecked( true );
    widget.timer->setChecked( true );
  }

  widget.showunrec->setChecked( settings.value( FiltersUnrec, false ).toBool() );
}

void FilterViewDialog::accept(){

  QSettings settings;
  if( widget.timer->isChecked() ){
    QAbstractButton * btn = bgroup->checkedButton();
    int months = bgroup->id( btn );
    settings.setValue( FiltersTime, months );
  }
  else {
    settings.remove( FiltersTime );
  }

  settings.setValue( FiltersUnrec, widget.showunrec->isChecked() );

  QDialog::accept();
}
