/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************/

#include <QSettings>

#include "GUIStore.h"
#include "Logger.h"
#include "Account.h"


GUIStore * GUIStore::instance = NULL;

GUIStore::GUIStore( ) : account( NULL ), journal( NULL ) {
}

GUIStore * GUIStore::getInstance( ) {
  if ( NULL == instance ) {
    instance = new GUIStore( );
  }

  return instance;
}

void GUIStore::setTransaction( const FullTransaction& t ) {
  if ( transaction != t ) {
    transaction = t;
    emit transactionChanged( transaction );
  }
}

void GUIStore::setAccount( const Account& a ) {
  account = &a;
}

void GUIStore::setJournal( const Journal& j ) {
  journal = &j;
}

const Account& GUIStore::getAccount( ) const {
  return *account;
}

const Journal& GUIStore::getJournal( ) const {
  return *journal;
}

const FullTransaction& GUIStore::getTransaction( ) const {
  return transaction;
}

