/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************/

#ifndef GUISTORE_H
#define	GUISTORE_H

#include "FullTransaction.h"

class Account;
class Journal;

class GUIStore : public QObject {
  Q_OBJECT
public:
  virtual ~GUIStore( ){}
  static GUIStore * getInstance( );

  void setTransaction( const FullTransaction& t );
  void setAccount( const Account& a );
  void setJournal( const Journal& j );

  const Account& getAccount( ) const;
  const Journal& getJournal( ) const;
  const FullTransaction& getTransaction( ) const;

signals:
  void transactionChanged( const FullTransaction& newer );

private:
  GUIStore( );

  const Account * account;
  const Journal * journal;
  FullTransaction transaction;

  static GUIStore * instance;
};

#endif	/* GUISTORE_H */

