/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2010 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ************************** * * * * * * * * * * * * **************************/


#ifndef JOURNALVIEWER_H
#define	JOURNALVIEWER_H

#include <QTabWidget>
#include <QHash>

#include "Journal.h"

class Account;
class FullTransaction;

class JournalViewer : public QTabWidget {
  Q_OBJECT
public:
  JournalViewer( QWidget * p = 0 );
  virtual ~JournalViewer( ){}

  void refresh( );
  void selectJournal( const Journal& );
  bool isFiltering() const;

public slots:
  void changeJournal( int index );
  void changeAccount( const Account& );
  void sendEditTrans( const FullTransaction& ft );
  void changeFilters();

  void saveSettings();
  void restoreSettings();

signals:
  void journalSelected( const Journal& );
  void editTrans( const FullTransaction& ft );

private:
  bool filtering;
  Journal current;
  QHash<int, Journal> idJournalLkp;
  QHash<int, int> journalIdLkp;
};

#endif	/* JOURNALVIEWER_H */

