/*
 * File:   MainWindow.h
 * Author: ryan
 *
 * Created on July 8, 2010, 6:11 PM
 */

#ifndef _MAINWINDOW_H
#define	_MAINWINDOW_H

#include "ui_MainWindow.h"

class Account;
class Journal;
class FullTransaction;
class QButtonGroup;

class QLabel;

class MainWindow : public QMainWindow {
  Q_OBJECT
public:
  MainWindow( );
  virtual ~MainWindow();

public slots:
  void changeAccount( const Account& );
  void changeJournal( const Journal& );
  void accountUpdated( const Account& older, const Account& newer );
  void openGraph( int );
  void openMemorizedTransactionEditor( );
  void openReconcile();
  void openPreferences();
  void openLoans();
  void openBudgets();
  void openViewFilters();
  void newAccount( );
  void editAccount( );
  void editTrans( const FullTransaction& t );
  void checkBudgets( const Account& newer );
  void openQuickEntry();
  void addCurrentToFavorites();
  void removeCurrentFromFavorites();
  void quickAccountSelected( int id );

  void restoreSettings( );
  void saveSettings( );

protected:
  void closeEvent( QCloseEvent * );

private:
  Ui::MainWindow widget;
  QLabel * balanceText;
  QLabel * messageText;
  QButtonGroup * faves;
  QButtonGroup * populars;

  void initFromSettings( );
  void initPopulars();
  void modifyFavories( const Account&, bool add );

  static const int GRAPH_MBALANCE;
  static const int GRAPH_MCHANGE;
  static const int GRAPH_DBALANCE;
  static const int GRAPH_DCHANGE;
  static const int GRAPH_CPIE;
  static const int GRAPH_DPIE;
  static const int GRAPH_BUDGET;
};

#endif	/* _MAINWINDOW_H */
