#include "MoneyDelegate.h"

#include <QLineEdit>

#include "Logger.h"
#include "MoneyEdit.h"


MoneyDelegate::MoneyDelegate(QObject *parent) : QStyledItemDelegate( parent ){
}

void MoneyDelegate::updateEditorGeometry( QWidget *editor,
                                          const QStyleOptionViewItem &option,
                                          const QModelIndex & ) const {
  editor->setGeometry( option.rect );
}

void MoneyDelegate::setModelData( QWidget *editor, QAbstractItemModel *model,
                     const QModelIndex &index ) const {
  MoneyEdit * edit = static_cast<MoneyEdit *> ( editor );
  Money sum = edit->getMoney();
  model->setData( index, sum.toString(), Qt::EditRole );
}

QWidget * MoneyDelegate::createEditor( QWidget *parent,
                                       const QStyleOptionViewItem&,
                                       const QModelIndex& ) const {
  MoneyEdit * edit = new MoneyEdit( parent );
  return edit;
}

void MoneyDelegate::setEditorData( QWidget * editor,
                                   const QModelIndex &index ) const {
  MoneyEdit * edit = static_cast<MoneyEdit *> ( editor );
  edit->setText( index.data().toString() );
}
