#include "MoneyEdit.h"

#include "Logger.h"

MoneyEdit::MoneyEdit( QWidget * parent ) : QLineEdit( parent ) {
}

Money MoneyEdit::getMoney() const {
  Money sum( 0 );
  QString txt = text().replace( " ", "" );
  QRegExp reg( "[+/*xX-]" );
  if( txt.contains( reg ) ){
    // there's some math to evaluate
    const int ADD = 0;
    const int DIV = 1;
    const int MUL = 2;
    const int SUB = 3;

    int pos = 0;
    int nextop = ADD;
    while( ( pos = txt.indexOf( reg ) ) != -1 ){
      QString sumstr = txt.left( pos );
      txt = txt.mid( pos );
      Money mon = Money::getMoney( sumstr );
      switch( nextop ){
        case ADD:
          sum += mon;
          break;
        case DIV:
          sum = Money( sum.getValue() / mon.getValue() );
          break;
        case MUL:
          sum = Money( sum.getValue() * mon.getValue() );
          break;
        case SUB:
          sum -= mon;
          break;
      }

      QString opstr = txt.left( 1 );
      if( "+" == opstr ){
        nextop = ADD;
      }
      else if( "-" == opstr ){
        nextop = SUB;
      }
      else if( "/" == opstr ){
        nextop = DIV;
      }
      else {
        nextop = MUL;
      }
      txt = txt.mid( 1 );
    }

    Money mon = Money::getMoney( txt );
    switch( nextop ){
      case ADD:
        sum += mon;
        break;
      case DIV:
        sum = Money( sum.getValue() / mon.getValue() );
        break;
      case MUL:
        sum = Money( sum.getValue() * mon.getValue() );
        break;
      case SUB:
        sum -= mon;
        break;
    }
  }
  else {
    sum = Money::getMoney( txt );
  }

  return sum;
}
