/*
 * File:   PlotWindow.h
 * Author: ryan
 *
 * Created on November 21, 2011, 3:44 PM
 */

#ifndef PLOTWINDOW_H
#define	PLOTWINDOW_H

#include "ui_PlotWindow.h"

#include <QList>

class PlotGenerator;

enum TimeScale { YEARLY, MONTHLY, DAILY, ACCOUNTS, NONE };

class PlotWindow : public QDialog {
  Q_OBJECT
public:
  virtual ~PlotWindow( );

public slots:
  virtual void replot( );
  virtual void add() = 0;

protected:
  PlotWindow( PlotGenerator * generator, QWidget * p = 0 );

  void setGenerator( PlotGenerator * gen );
  void addGenerator( PlotGenerator * gen );
  void clearGenerators( );
  void clearLegend();
  virtual void init();
  virtual TimeScale timescale() const = 0;

  Ui::PlotWindow widget;
  QList<PlotGenerator *> generators;
  bool loading;
};

#endif	/* PLOTWINDOW_H */

