#include "PreferencesDialog.h"
#include "ui_PreferencesDialog.h"

#include <QSettings>
#include <QPushButton>

#include "Constants.h"

PreferencesDialog::PreferencesDialog( QWidget *parent ) : QDialog( parent ) {
  ui.setupUi( this );

  QSettings settings;
  ui.dater->setText( settings.value( DateFormat ).toString() );
  ui.allsplits->setChecked( settings.value( ShowAllTrans ).toBool() );
  ui.currencysep->setText( settings.value(CurrencySeparator).toString() );
  ui.accountsep->setText( settings.value(AccountSeparator).toString( ) );
  ui.allpayees->setChecked( settings.value( ShowAllPayees ).toBool() );
  ui.currencysymbol->setText( settings.value( CurrencySymbol ).toString() );
  ui.quickentry->setChecked( settings.value( StartInQuickEntry ).toBool() );

  connect( ui.buttonBox->button( QDialogButtonBox::Ok ), SIGNAL( clicked() ),
           SLOT( savePrefs() ) );
}

void PreferencesDialog::savePrefs(){
  QSettings settings;
  settings.setValue( DateFormat, ui.dater->text() );
  settings.setValue( ShowAllTrans, ui.allsplits->isChecked() );
  settings.setValue( CurrencySeparator, ui.currencysep->text() );
  settings.setValue( AccountSeparator, ui.accountsep->text() );
  settings.setValue( ShowAllPayees, ui.allpayees->isChecked() );
  settings.setValue( CurrencySymbol, ui.currencysymbol->text() );
  settings.setValue( StartInQuickEntry, ui.quickentry->isChecked() );
}
