/*
 * File:   ReconcileDelegate.cpp
 * Author: ryan
 *
 * Created on November 30, 2011, 2:16 PM
 */

#include <QCheckBox>

#include "ReconcileDelegate.h"
#include "Constants.h"

ReconcileDelegate::ReconcileDelegate( QObject * p ) : BoolDelegate( true, p ) {
}

void ReconcileDelegate::setEditorData( QWidget * editor,
    const QModelIndex &index ) const {
  QCheckBox * qcb = static_cast<QCheckBox *> ( editor );
  ReconcileState rs =
      static_cast<ReconcileState> ( index.data( Qt::UserRole ).toInt( ) );
  if ( No == rs ) {
    qcb->setCheckState( Qt::Unchecked );
  }
  else if ( Maybe == rs ) {
    qcb->setCheckState( Qt::PartiallyChecked );
  }
  else {
    qcb->setCheckState( Qt::Checked );
  }
}

void ReconcileDelegate::setModelData( QWidget *editor, QAbstractItemModel *model,
    const QModelIndex &index ) const {
  QCheckBox * qcb = static_cast<QCheckBox *> ( editor );
  Qt::CheckState cs = qcb->checkState( );

  ReconcileState rs = Yes;
  if ( Qt::Unchecked == cs ) {
    rs = No;
  }
  else if ( Qt::PartiallyChecked == cs ) {
    rs = Maybe;
  }

  model->setData( index, rs, Qt::EditRole );
}
