/*
 * File:   ReconcileSplitView.h
 * Author: ryan
 *
 * Created on December 6, 2011, 2:31 PM
 */

#ifndef RECONCILESPLITVIEW_H
#define	RECONCILESPLITVIEW_H

#include "TransactionViewer.h"
#include "Split.h"
#include "TransactionFilter.h"
#include "ReconcileFilter.h"
#include "DateRangeFilter.h"

#include <QList>
#include <QDate>
#include <QHash>

class QWidget;
class QKeyEvent;

class ReconcileSplitView : public TransactionViewer {
  Q_OBJECT
public:
  ReconcileSplitView( QWidget * p = 0 );
  virtual ~ReconcileSplitView( ){}

  QList<Split> getSplits( );

public slots:
  void toggle( QTreeWidgetItem *, int );
  virtual void addTrans( const FullTransaction& );
  virtual void changeSplit( const Split&, const Split& );
  virtual void changeAccount(const Account &newone);
  void setEndDate( const QDate& = QDate::currentDate( ) );
  void clear();

signals:
  void reconcileChanged( );

protected:
  void keyPressEvent( QKeyEvent * );
  virtual bool shouldIncludeTrans( const FullTransaction& );

private:
  QDate ender;
  QHash<int, Split> splits;
  QHash<int, QTreeWidgetItem *> items;
  ReconcileFilter recofilter;
  DateRangeFilter datefilter;

  friend class ReconcileWindow;
};

#endif	/* RECONCILESPLITVIEW_H */

