/*
 * File:   SplitsView.h
 * Author: ryan
 *
 * Created on November 30, 2011, 2:39 PM
 */

#ifndef SPLITSVIEW_H
#define	SPLITSVIEW_H

#include <QTreeView>
#include <memory>

#include "Split.h"
#include "SplitModel.h"

class Money;
class AccountDelegate;
class ReconcileDelegate;
class MoneyDelegate;

class SplitsView : public QTreeView {
  Q_OBJECT
public:
  SplitsView( QWidget * p = 0 );
  virtual ~SplitsView( );

  void setSplits( QList<Split> );
  Money getDifference( ) const;
  const QList<Split>& getSplits() const;
  QModelIndex moveCursor ( CursorAction action, Qt::KeyboardModifiers mods );

public slots:
  void addSplit( );
  void changeMemo( const QString& str );
  // virtual void edit( const QModelIndex & index );
  // virtual bool edit( const QModelIndex & index, EditTrigger, QEvent * );
  virtual void saveSettings( const QString& key ) const;
  virtual void restoreSettings( const QString& key );

signals:
  void differenceChanged( const Money& older, const Money& newer );

private:
  std::unique_ptr<SplitModel> mmodel;
  std::unique_ptr<AccountDelegate> adele;
  std::unique_ptr<ReconcileDelegate> rdele;
  std::unique_ptr<MoneyDelegate> mdele;
};

#endif	/* SPLITSVIEW_H */

