/*
 * File:   StartDialog.cpp
 * Author: ryan
 *
 * Created on December 3, 2011, 7:54 PM
 */

#include "StartupDialog.h"

#include <QFileDialog>
#include <QDirModel>
#include <QCompleter>

StartupDialog::StartupDialog( QWidget * p ) : QDialog( p ) {
  widget.setupUi( this );
  setAttribute( Qt::WA_DeleteOnClose, false );

  QCompleter * comp=new QCompleter( this );
  comp->setModel( new QDirModel( comp ) );
  widget.dbloc->setCompleter( comp );

  connect( widget.browser, SIGNAL( clicked( ) ), SLOT( openFileDialog( ) ) );
}

void StartupDialog::openFileDialog( ) {
  QString file = QFileDialog::getOpenFileName( this, tr( "Locate Database" ) );
  widget.dbloc->setText( file );
}

QString StartupDialog::getDb( ) const {
  return widget.dbloc->text( );
}
