#include "TransactionDelegateBase.h"

#include <QPainter>

#include "AccountViewer.h"

TransactionDelegateBase::TransactionDelegateBase(QObject *parent) :
  QStyledItemDelegate( parent ){
}

void TransactionDelegateBase::paint( QPainter * p,
                                     const QStyleOptionViewItem& option,
                                     const QModelIndex& index ) const {
  if( index.data(AccountViewer::ISTRANSROLE ).toBool() ){
    QStyleOptionViewItemV4 opt(option);
    initStyleOption( &opt, index );
    QRect rect = opt.rect;

    p->save();

    QLinearGradient linearGrad(rect.left(), rect.top(),
                               rect.left(), rect.top() + 5);
    linearGrad.setColorAt(0, option.palette.color( QPalette::AlternateBase ) );
    linearGrad.setColorAt(1, option.palette.color( QPalette::Base));
    p->fillRect(rect, linearGrad);

    p->restore();
  }

  QStyledItemDelegate::paint( p, option, index );
}
