/*
 * File:   TransactionViewer.h
 * Author: ryan
 *
 * Created on December 13, 2011, 6:23 PM
 */

#ifndef TRANSACTIONVIEWER_H
#define	TRANSACTIONVIEWER_H

#include <QTreeWidget>
#include <vector>
#include <memory>

#include "Account.h"
#include "Journal.h"
#include "TransactionFilter.h"

class FullTransaction;

class TransactionViewer : public QTreeWidget {
  Q_OBJECT
public:
  TransactionViewer( QWidget * p = 0 );
  virtual ~TransactionViewer( ){}

  void setJournal( const Journal& );
  const Journal& getJournal( ) const;

  void setAccount( const Account& );
  virtual void addCustomFilter( std::unique_ptr<TransactionFilter> tf );
  virtual void clearCustomFilters();

public slots:
  virtual void changeAccount( const Account& newone );
  virtual void saveSettings( const QString& key );
  virtual void restoreSettings( const QString& key );

protected:
  virtual bool shouldIncludeTrans( const FullTransaction& );
  virtual void addTrans( const FullTransaction& ) = 0;
  virtual void cleanup();

  static const int DATEROLE;
  Account account;
  Journal journal;
  bool loading;
  std::vector<std::unique_ptr<TransactionFilter> > filters;
  std::vector<std::unique_ptr<TransactionFilter> > customfilters;
};

#endif	/* TRANSACTIONVIEWER_H */
