#include "CompositeFilter.h"

CompositeFilter::CompositeFilter(): isOr( false ){}

 void CompositeFilter::add( std::unique_ptr<TransactionFilter> f ){
   filters.push_back( std::move( f ) );
 }

void CompositeFilter::setOr( bool doOr ) {
  isOr = doOr;
}

bool CompositeFilter::iaccept( const FullTransaction& ft ){
  bool ok = ( isOr ? false : true );

  for( const auto& p : filters ){
    if( isOr ){
      bool pok = p->accepts( ft );
      ok = ok || pok;
    }
    else {
      ok = ok && p->accepts( ft );

      if( !ok ){
        break;
      }
    }
  }

  return ok;
}
