#ifndef COMPOSITEFILTER_H
#define COMPOSITEFILTER_H

#include "TransactionFilter.h"

#include <vector>
#include <memory>

class FullTransaction;

/**
 * An filter that ANDs (or ORs) a set of other filters together
 */
class CompositeFilter : public TransactionFilter {
public:
  CompositeFilter();
  ~CompositeFilter(){}

  void add( std::unique_ptr<TransactionFilter> f );

  void setOr( bool doOr = true );



protected:
  std::vector<std::unique_ptr<TransactionFilter> > filters;
  bool isOr;

  virtual bool iaccept( const FullTransaction& ft );
};

#endif // COMPOSITEFILTER_H
