#ifndef DATERANGEFILTER_H
#define DATERANGEFILTER_H

#include <QDate>

#include "TransactionFilter.h"

class DateRangeFilter : public TransactionFilter {
public:
  DateRangeFilter( const QDate& earliest = QDate(),
                   const QDate& latest = QDate() );
  DateRangeFilter( const DateRangeFilter& orig );
  virtual ~DateRangeFilter(){}

  DateRangeFilter& operator=( const DateRangeFilter& orig );

  /**
   * Sets the acceptable date range. To unset either value,
   * send an invalid date
   */
  virtual void setRange( const QDate& sd, const QDate& ed );

  /**
   * Sets the starting acceptable date. To unset the start date,
   * send an invalid date
   */

  virtual void setEarliest( const QDate& sd );
  /**
   * Sets the ending acceptable date. To unset the end date,
   * send an invalid date
   */
  virtual void setLatest( const QDate& sd );

protected:
  virtual bool iaccept( const FullTransaction& ft );

private:
  QDate earliestDate;
  QDate latestDate;
};

#endif // DATERANGEFILTER_H
