#include "ReconcileFilter.h"

#include "FullTransaction.h"
#include "Transaction.h"

ReconcileFilter::ReconcileFilter( const Account& acct, const ReconcileState& rs ) :
  reco( rs ), account( acct ){}

ReconcileFilter::ReconcileFilter( const ReconcileFilter& orig) :
  TransactionFilter( orig ), reco( orig.reco ), account( orig.account ){}

ReconcileFilter& ReconcileFilter::operator=( const ReconcileFilter& orig ){
  if( this != &orig ){
    TransactionFilter::operator=( orig );
    reco = orig.reco;
    account = orig.account;
  }

  return *this;
}

bool ReconcileFilter::iaccept( const FullTransaction& ft ){
  if( ft.hasSplitForAccount( account ) ){
    const ReconcileState RS( ft[account].getReconciled() );
    return ( antiReco ? RS != reco : RS == reco );
  }

  return false;
}

void ReconcileFilter::setAccount( const Account& acct ){
  account = acct;
}

void ReconcileFilter::setReconciledState( const ReconcileState& rs ){
  reco = rs;
  antiReco = false;
}

void ReconcileFilter::setAntiReconciledState( const ReconcileState& rs ){
  reco = rs;
  antiReco = true;
}
