#ifndef RECONCILEFILTER_H
#define RECONCILEFILTER_H

#include "TransactionFilter.h"
#include "Constants.h"
#include "IDableEntity.h"
#include "Account.h"

class ReconcileFilter : public TransactionFilter {
public:
  ReconcileFilter( const Account& acct, const ReconcileState& rs = Yes );
  ReconcileFilter( const ReconcileFilter& orig );
  ReconcileFilter& operator=( const ReconcileFilter& orig );
  virtual ~ReconcileFilter(){}

  void setAccount( const Account& acct );
  void setReconciledState( const ReconcileState& rs );
  void setAntiReconciledState( const ReconcileState& rs );

protected:
  virtual bool iaccept( const FullTransaction& ft );

private:
  ReconcileState reco;
  bool antiReco;
  Account account;
};

#endif // RECONCILEFILTER_H
