/*
 * File:   BalanceBase.h
 * Author: ryan
 *
 * Created on November 21, 2011, 3:13 PM
 */

#ifndef GRAPHBALANCE_H
#define	GRAPHBALANCE_H

#include "PlotGenerator.h"

class BalanceBase : public AccountGenerator {
public:
  BalanceBase( const Account& a, const QDate& s = QDate( ),
      const QDate& e = QDate::currentDate( ) );
  BalanceBase( const BalanceBase& orig );
  BalanceBase& operator=(const BalanceBase& orig);

  virtual ~BalanceBase( ){}

  virtual std::unique_ptr<QwtPlotItem> getPlot( const QPen& pen = QPen( ) );

protected:
  virtual QString dateFormat() const = 0;
  virtual QDate incrementTick( const QDate& date ) = 0;
  virtual bool sumThroughTicks() const = 0;
};

#endif	/* GRAPHBALANCE_H */

