#include "BalancePlot.h"

#include "Balance.h"
#include "QHacc.h"
#include "AccountMapper.h"

BalancePlot::BalancePlot( BalanceBase * gen, QWidget * p ) : PlotWindow( gen, p ) {
}

void BalancePlot::add(){
  int idx = widget.accounts->currentIndex();
  int aid = widget.accounts->itemData( idx ).toInt();
  AccountMapper& amap = QHacc::getInstance()->getAccountMapper();
  std::unique_ptr<PlotGenerator> pg( getNewPlot( amap.getById( aid ) ) );
  addGenerator( pg.release() );
}
