#ifndef BUDGETING_H
#define BUDGETING_H

#include "PlotGenerator.h"

#include "Budget.h"

class Budgeting : public PlotGenerator {
public:
  Budgeting( bool actual = false, const QDate& endTime = QDate::currentDate() );
  Budgeting( const Budget& a, bool actual = false,
             const QDate& endTime = QDate::currentDate() );
  virtual ~Budgeting(){}
  virtual QString getTitle() const;
  virtual std::unique_ptr<QwtPlotItem> getPlot( const QPen& = QPen( ) );
  virtual std::map<QString, std::pair<QColor, QString> > legendMap() const;

  void setBudget( const Budget& b );
  const Budget& getBudget() const{
    return budget;
  }

private:
  Budget budget;
  bool actual;
  QString pct;
};

#endif // BUDGETING_H
