/*
 * File:   MonthlyBalance.h
 * Author: ryan
 *
 * Created on November 21, 2011, 3:13 PM
 */

#ifndef DAILYCHANGE_H
#define	DAILYCHANGE_H

#include "Balance.h"

class DailyChange : public BalanceBase {
public:
  DailyChange( const Account& a, const QDate& s = QDate( ),
               const QDate& e = QDate::currentDate( ) )
    : BalanceBase( a, s, e ){}
  DailyChange( const DailyChange& orig ) : BalanceBase( orig ){}

  virtual ~DailyChange( ){}

protected:
  virtual QString dateFormat() const {
    return "yyyyMMdd";
  }

  virtual QDate incrementTick( const QDate& date ) {
    return date.addDays( 1 );
  }

  virtual bool sumThroughTicks() const {
    return false;
  }
};

#endif	/* DAILYCHANGE_H */
