/*
 * File:   MonthlyBalance.h
 * Author: ryan
 *
 * Created on November 21, 2011, 3:13 PM
 */

#ifndef MONTHLYBALANCE_H
#define	MONTHLYBALANCE_H

#include "Balance.h"

class MonthlyBalance : public BalanceBase {
public:
  MonthlyBalance( const Account& a, const QDate& s = QDate( ),
      const QDate& e = QDate::currentDate( ) );
  MonthlyBalance( const MonthlyBalance& orig );

  virtual ~MonthlyBalance( ){}

protected:
  virtual QString dateFormat() const {
    return "yyyyMM";
  }

  virtual QDate incrementTick( const QDate& date ) {
    return date.addMonths( 1 );
  }

  virtual bool sumThroughTicks() const {
    return true;
  }
};

#endif	/* MONTHLYBALANCE_H */

