#ifndef PIEGRAPH_H
#define PIEGRAPH_H

#include <qwt_plot_item.h>

#include <map>

#include "PlotGenerator.h"
#include "Money.h"

class PieGraph : public AccountGenerator {
public:
  PieGraph( const Account& a, bool credits = true, const QDate& b = QDate( ),
            const QDate& e = QDate::currentDate( ) );
  PieGraph( const PieGraph& orig );
  virtual ~PieGraph( ){}
  PieGraph& operator=(const PieGraph& orig);

  virtual std::unique_ptr<QwtPlotItem> getPlot( const QPen& pen = QPen( ) );
  virtual std::map<QString, std::pair<QColor, QString> > legendMap() const;

private:
  std::map<QString, std::pair<QColor, QString> > legendInfo;
  bool credits;
};

class PieMarker : public QwtPlotItem {
public:
  PieMarker( const std::map<int, Money>& accountTotals );

  virtual int rtti() const;

  virtual void draw( QPainter * p, const QwtScaleMap&, const QwtScaleMap&,
      const QRectF& rect ) const;
  const std::map<QString, QColor>& colorMap() const;
  const std::map<QString, double>& percentMap() const;
  const Money& total() const {
    return mtotal;
  }

private:
  std::map<QString, double> accountTotals; // account name, total money
  std::map<QString, QColor> accountColors; // account name, color
  Money mtotal;
  void mergeSmallAccounts( unsigned int maxpies );
};


#endif // PIEGRAPH_H
