#include "PieWindow.h"

#include "PieGraph.h"

#include "QHacc.h"
#include "AccountMapper.h"

PieWindow::PieWindow( const Account& a, QWidget * p ) :
  PlotWindow( new PieGraph( a ), p ){
}

PieWindow::PieWindow( PieGraph * pg, QWidget * p ) : PlotWindow( pg, p ){
}

void PieWindow::add(){
  int idx = widget.accounts->currentIndex();
  int aid = widget.accounts->itemData( idx ).toInt();
  AccountMapper& amap = QHacc::getInstance()->getAccountMapper();
  addGenerator( getNewPlot( amap.getById( aid ) ) );
}

PieGraph * PieWindow::getNewPlot( const Account& a ){
  return new PieGraph( a );
}

TimeScale PieWindow::timescale() const {
  return NONE;
}


DebitPieWindow::DebitPieWindow( const Account& a, QWidget * p ) :
  PieWindow( new PieGraph( a, false ), p ){
}

PieGraph * DebitPieWindow::getNewPlot( const Account& a ){
  return new PieGraph( a, false );
}
