
########################################################
#                                                      #
#  You should not need to touch anything in this file  #
#                                                      #
########################################################

include ( ../user.pri )

DOLLAR = $
QMAKE_RPATHDIR +=$${DOLLAR}$${DOLLAR}ORIGIN/../lib
QMAKE_RPATHDIR +=$${LIBINSTALLDIR}

TEMPLATE = app
TARGET = qhacc
DEPENDPATH += . graphing resources filter
INCLUDEPATH += . resources graphing filter ../engine ../engine/mapper $${QWTINCS}
LIBS += -L../engine/$${DESTDIR} -lengine -L$${QWTLIBS} -lqwt
QT += gui
QT += sql

target.path = $${EXEINSTALLDIR}
INSTALLS += target

win32 {
  qwtlibo.path = $${LIBINSTALLDIR}
  qwtlibo.files = $${QWTLIBS}/qwt.dll \
	$$[QT_INSTALL_PREFIX]/bin/QtCore4.dll \
	$$[QT_INSTALL_PREFIX]/bin/QtCored4.dll \
	$$[QT_INSTALL_PREFIX]/bin/QtSql4.dll \
	$$[QT_INSTALL_PREFIX]/bin/QtGui4.dll \
	$$[QT_INSTALL_PREFIX]/bin/QtSvg4.dll
  INSTALLS += qwtlibo
}

# Input
HEADERS += \
    AccountChooser.h \
    AccountDelegate.h \
    AccountDialog.h \
    AccountViewer.h \
    DataEntry.h \
    DateDelegate.h \
    GUIStore.h \
    JournalViewer.h \
    MainWindow.h \
    MemTransDataEntry.h \
    PlotWindow.h \
    ReconcileDelegate.h \
    ReconcileSplitView.h \
    ReconcileWindow.h \
    SplitModel.h \
    SplitsView.h \
    StartupDialog.h \
    TransactionViewer.h \
    graphing/DayLabeler.h \
    graphing/MonthLabeler.h \
    graphing/MonthlyBalance.h \
    graphing/PlotGenerator.h \
    PreferencesDialog.h \
    TransactionDelegateBase.h \
    graphing/MonthlyChange.h \
    graphing/Balance.h \
    graphing/DailyChange.h \
    graphing/DailyBalance.h \
    SplitDialog.h \
    LoanDialog.h \
    graphing/PieGraph.h \
    AccountComboBox.h \
    BudgetDialog.h \
    BudgetLimitRowModel.h \
    graphing/Budgeting.h \
    graphing/BalancePlot.h \
    graphing/MonthlyBalanceWindow.h \
    graphing/MonthlyChangeWindow.h \
    graphing/DailyChangeWindow.h \
    graphing/DailyBalanceWindow.h \
    graphing/PieWindow.h \
    graphing/BudgetingWindow.h \
    graphing/AccountLabeler.h \
    BoolDelegate.h \
    QuickEntryDialog.h \
    MoneyDelegate.h \
    TransactionFilter.h \
    filter/DateRangeFilter.h \
    filter/TransactionTypeFilter.h \
    filter/ReconcileFilter.h \
    FilterViewDialog.h \
    filter/CompositeFilter.h \
    MoneyEdit.h
FORMS += \
    AccountDialog.ui \
    DataEntry.ui \
    MainWindow.ui \
    MemTransDataEntry.ui \
    PlotWindow.ui \
    ReconcileWindow.ui \
    StartupDialog.ui \
    PreferencesDialog.ui \
    SplitDialog.ui \
    LoanDialog.ui \
    BudgetDialog.ui \
    QuickEntryDialog.ui \
    FilterViewDialog.ui
SOURCES += AccountChooser.cpp \
    AccountDelegate.cpp \
    AccountDialog.cpp \
    AccountViewer.cpp \
    DataEntry.cpp \
    DateDelegate.cpp \
    GUIStore.cpp \
    JournalViewer.cpp \
    main.cpp \
    MainWindow.cpp \
    MemTransDataEntry.cpp \
    PlotWindow.cpp \
    ReconcileDelegate.cpp \
    ReconcileSplitView.cpp \
    ReconcileWindow.cpp \
    SplitModel.cpp \
    SplitsView.cpp \
    StartupDialog.cpp \
    TransactionViewer.cpp \
    graphing/DayLabeler.cpp \
    graphing/MonthLabeler.cpp \
    graphing/MonthlyBalance.cpp \
    graphing/PlotGenerator.cpp \
    PreferencesDialog.cpp \
    TransactionDelegateBase.cpp \
    graphing/MonthlyChange.cpp \
    graphing/Balance.cpp \
    SplitDialog.cpp \
    LoanDialog.cpp \
    graphing/PieGraph.cpp \
    AccountComboBox.cpp \
    BudgetDialog.cpp \
    BudgetLimitRowModel.cpp \
    graphing/Budgeting.cpp \
    graphing/BalancePlot.cpp \
    graphing/MonthlyBalanceWindow.cpp \
    graphing/MonthlyChangeWindow.cpp \
    graphing/DailyChangeWindow.cpp \
    graphing/DailyBalanceWindow.cpp \
    graphing/PieWindow.cpp \
    graphing/BudgetingWindow.cpp \
    graphing/AccountLabeler.cpp \
    BoolDelegate.cpp \
    QuickEntryDialog.cpp \
    MoneyDelegate.cpp \
    TransactionFilter.cpp \
    filter/DateRangeFilter.cpp \
    filter/TransactionTypeFilter.cpp \
    filter/ReconcileFilter.cpp \
    FilterViewDialog.cpp \
    filter/CompositeFilter.cpp \
    MoneyEdit.cpp
RESOURCES += \
    resources/styles.qrc
